local EZWand = dofile_once("mods/player_ghost/lib/EZWand/EZWand.lua")

max_amount_saved = max_amount_saved or ModSettingGet("player_ghost.max_amount_saved")
spawn_chance_percent = spawn_chance_percent or ModSettingGet("player_ghost.spawn_chance_percent")
wands_required_count = wands_required_count or ModSettingGet("player_ghost.wands_required_count")

-- Returns the indexes of wand save slots which have been saved
local function get_saved_wand_indexes()
  local valid_indexes = {}
  for i=1, max_amount_saved do
    if ModSettingGet("player_ghost.wand"..i) then
      table.insert(valid_indexes, i)
    end
  end
  return valid_indexes
end

local function load_saved_wand(valid_indexes, x, y)
  -- Pick one at random
  local random_index = valid_indexes[Random(1, #valid_indexes)]
  local serialized_wand = ModSettingGet("player_ghost.wand"..random_index)
  -- Delete it after we restored it
  ModSettingRemove("player_ghost.wand"..random_index)
  local wand = EZWand(serialized_wand, x, y)
end

function spawn_apparition(x, y)
	SetRandomSeed(x, y)
  local valid_indexes = get_saved_wand_indexes()
  -- Only spawn one per run, at a certain chance per spot and only if more than a certain amount of wands are stored
  if #valid_indexes >= wands_required_count and Random(1, 100) <= spawn_chance_percent and not GameHasFlagRun("player_ghost_spawned") then
    GameAddFlagRun("player_ghost_spawned")
    EntityLoad("data/entities/animals/apparition/playerghost.xml", x, y)
    load_saved_wand(valid_indexes, x, y)
    LoadPixelScene( "data/biome_impl/grave.png", "data/biome_impl/grave_visual.png", x-10, y-15, "", true )
  else
    for i=1,4 do
			local rx = x + Random( -10, 10 )
			spawn_candles(rx, y)
		end
  end
end
