local EZWand = dofile_once("mods/player_ghost/lib/EZWand/EZWand.lua")

local max_amount_saved = ModSettingGet("player_ghost.max_amount_saved")

local function entity_is_wand(entity_id)
	local comp = EntityGetComponentIncludingDisabled(entity_id, "ManaReloaderComponent")
	return comp ~= nil
end

function pick_random_held_wand()
  local inventory = EntityGetWithName("inventory_quick")
  local wands = {}
  for i, entity_id in ipairs(EntityGetAllChildren(inventory) or {}) do
    if entity_is_wand(entity_id) then
      table.insert(wands, entity_id)
    end
  end
  SetRandomSeed(GameGetFrameNum(), GameGetFrameNum())
  local random_index = Random(1, #wands)
  local wand = EZWand(wands[random_index])
  return wand
end

function death(damage_type_bit_field, damage_message,entity_thats_responsible, drop_items)
  local wand = pick_random_held_wand()
  -- Find first free wand save slot, we only store 30 wands max
  local free_slot = 0
  for i=1, max_amount_saved do
    if not ModSettingGet("player_ghost.wand"..i) then
      free_slot = i
      break
    end
  end
  if free_slot > 0 then
    ModSettingSet("player_ghost.wand"..free_slot, wand:Serialize())
  else
    -- No free slot, overwrite one at random?
    free_slot = Random(1,max_amount_saved)
    ModSettingSet("player_ghost.wand"..free_slot, wand:Serialize())
  end
end
